unit DatGPro;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FileCtrl, Db, DBClient, IBServices, MyConst;

type
  TDmGpro = class(TDataModule)
    IBBackupService1: TIBBackupService;
    cdsDBOptionSetting: TClientDataSet;
    dsDBOptionSetting: TDataSource;
    cdsDBOptionSettingServerAlias: TStringField;
    cdsDBOptionSettingBackupAlias: TStringField;
    cdsDBOptionSettingFormat: TStringField;
    cdsDBOptionSettingMetadataOnly: TStringField;
    cdsDBOptionSettingGarbageCollection: TStringField;
    cdsDBOptionSettingTransactionInLimbo: TStringField;
    cdsDBOptionSettingChecksums: TStringField;
    cdsDBOptionSettingConvertToTables: TStringField;
    cdsDBOptionSettingVerboseOutput: TStringField;
    IBValidationService1: TIBValidationService;
    cdsDBOptionSettingAutoTerminate: TStringField;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DmGpro: TDmGpro;

implementation

{$R *.DFM}

procedure TDmGpro.DataModuleCreate(Sender: TObject);
var
  path : String;
begin
  path := ExtractFilePath(Application.ExeName);

  ForceDirectories(Path + Dir_CDS);
  ForceDirectories(Path + Dir_Log);

  If FileExists (path + Dir_CDS + File_OptionSetting ) Then
    Begin
      cdsDBOptionSetting.LoadFromFile(path + Dir_CDS + File_OptionSetting);
      cdsDBOptionSetting.FileName := path + Dir_CDS + File_OptionSetting;
    End
  Else
    Begin
      cdsDBOptionSetting.CreateDataSet;
      cdsDBOptionSetting.SaveToFile(path + Dir_CDS + File_OptionSetting);
      cdsDBOptionSetting.FileName := path + Dir_CDS + File_OptionSetting;
    End;
end;

procedure TDmGpro.DataModuleDestroy(Sender: TObject);
begin
  Try
    cdsDBOptionSetting.FileName := '';
    cdsDBOptionSetting.EmptyDataSet;
  Finally
  End;
end;

end.
