unit Validate;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

  Function FEncode(pStr: string): string;
  Function FDecode(pStr: string):string;
  Procedure GenAnsiCode;
  Function KeyBdCode(pKeyBdChar: string):smallint;
  Function KeyBdChar(pKeyBdCode: smallint): string;
  Function SysDefCode(pSysDefChar: string):smallint;
  Function SysDefChar(pSysDefCode: smallint):string;

implementation

var
  vKeyBdChar : array[0..93] of char;
  vSysDefChar: array[0..93] of char;
  
Function FEncode(pStr: String): string;
var vStrLen, I : Integer;
    vEncode    : String;
begin
  GenAnsiCode;
  vStrLen := Length(pStr);
  vEncode := '';
  if vStrLen > 0 then begin
     for I := 1 to vStrLen do begin
       vEncode := vEncode + SysDefChar(KeyBdCode(copy(pStr,i,1)));
     end;
  end;
  result := vEncode;
end;

Function FDecode(pStr: String):string;
var vStrLen, I : Integer;
    vdecode    : String;
begin
  GenAnsiCode;
  vStrLen := Length(pStr);
  vdecode := '';
  if vStrLen > 0 then begin
     for I := 1 to vStrLen do begin
       vdecode := vdecode + KeyBdChar(SysDefCode(copy(pStr,i,1)));
     end;
  end;
  result := vdecode;
end;

procedure GenAnsiCode;
var i, vInitial: smallint;
begin
  // Keyboard's key
  vInitial := 33;
  for i := 0 to 93 do begin
    vKeyBdChar[i] := chr(vInitial+i);
  end;
  // user define a special key
  // 0-9
  vSysDefChar[0] := chr(111);
  vSysDefChar[1] := chr(93);
  vSysDefChar[2] := chr(101);
  vSysDefChar[3] := chr(40);
  vSysDefChar[4] := chr(95);
  vSysDefChar[5] := chr(34);
  vSysDefChar[6] := chr(62);
  vSysDefChar[7] := chr(81);
  vSysDefChar[8] := chr(115);
  vSysDefChar[9] := chr(86);
  // 10-19
  vSysDefChar[10] := chr(39);
  vSysDefChar[11] := chr(41);
  vSysDefChar[12] := chr(37);
  vSysDefChar[13] := chr(85);
  vSysDefChar[14] := chr(92);
  vSysDefChar[15] := chr(42);
  vSysDefChar[16] := chr(88);
  vSysDefChar[17] := chr(109);
  vSysDefChar[18] := chr(110);
  vSysDefChar[19] := chr(49);
  // 20-29
  vSysDefChar[20] := chr(122);
  vSysDefChar[21] := chr(53);
  vSysDefChar[22] := chr(118);
  vSysDefChar[23] := chr(38);
  vSysDefChar[24] := chr(124);
  vSysDefChar[25] := chr(117);
  vSysDefChar[26] := chr(71);
  vSysDefChar[27] := chr(91);
  vSysDefChar[28] := chr(104);
  vSysDefChar[29] := chr(79);
  // 30-39
  vSysDefChar[30] := chr(54);
  vSysDefChar[31] := chr(67);
  vSysDefChar[32] := chr(82);
  vSysDefChar[33] := chr(125);
  vSysDefChar[34] := chr(84);
  vSysDefChar[35] := chr(68);
  vSysDefChar[36] := chr(114);
  vSysDefChar[37] := chr(61);
  vSysDefChar[38] := chr(50);
  vSysDefChar[39] := chr(33);
  // 40-49
  vSysDefChar[40] := chr(126);
  vSysDefChar[41] := chr(45);
  vSysDefChar[42] := chr(80);
  vSysDefChar[43] := chr(51);
  vSysDefChar[44] := chr(63);
  vSysDefChar[45] := chr(87);
  vSysDefChar[46] := chr(94);
  vSysDefChar[47] := chr(47);
  vSysDefChar[48] := chr(60);
  vSysDefChar[49] := chr(107);
  // 50-59
  vSysDefChar[50] := chr(120);
  vSysDefChar[51] := chr(103);
  vSysDefChar[52] := chr(44);
  vSysDefChar[53] := chr(102);
  vSysDefChar[54] := chr(52);
  vSysDefChar[55] := chr(73);
  vSysDefChar[56] := chr(48);
  vSysDefChar[57] := chr(96);
  vSysDefChar[58] := chr(100);
  vSysDefChar[59] := chr(58);
  // 60-69
  vSysDefChar[60] := chr(99);
  vSysDefChar[61] := chr(105);
  vSysDefChar[62] := chr(89);
  vSysDefChar[63] := chr(55);
  vSysDefChar[64] := chr(106);
  vSysDefChar[65] := chr(83);
  vSysDefChar[66] := chr(108);
  vSysDefChar[67] := chr(69);
  vSysDefChar[68] := chr(35);
  vSysDefChar[69] := chr(98);
  // 70-79
  vSysDefChar[70] := chr(43);
  vSysDefChar[71] := chr(123);
  vSysDefChar[72] := chr(56);
  vSysDefChar[73] := chr(65);
  vSysDefChar[74] := chr(46);
  vSysDefChar[75] := chr(119);
  vSysDefChar[76] := chr(75);
  vSysDefChar[77] := chr(97);
  vSysDefChar[78] := chr(59);
  vSysDefChar[79] := chr(70);
  // 80-89
  vSysDefChar[80] := chr(112);
  vSysDefChar[81] := chr(66);
  vSysDefChar[82] := chr(121);
  vSysDefChar[83] := chr(77);
  vSysDefChar[84] := chr(76);
  vSysDefChar[85] := chr(57);
  vSysDefChar[86] := chr(113);
  vSysDefChar[87] := chr(74);
  vSysDefChar[88] := chr(116);
  vSysDefChar[89] := chr(78);
  // 90-95
  vSysDefChar[90] := chr(72);
  vSysDefChar[91] := chr(64);
  vSysDefChar[92] := chr(36);
  vSysDefChar[93] := chr(90);
end;

Function KeyBdCode(pKeyBdChar: string):smallint;
var i: smallint;
begin
  result := -1;
  for i:= 0 to 93 do begin
    if pKeyBdChar = vKeyBdChar[i] then begin
       result := i;
       break;
    end;
  end;
end;

Function SysDefCode(pSysDefChar: string):smallint;
var i: smallint;
begin
  result := -1;
  for i := 0 to 93 do begin
    if pSysDefChar = vSysDefChar[i] then begin
       result := i;
       break;
    end;
  end;
end;

Function SysDefChar(pSysDefCode: smallint):string;
var i: smallint;
begin
  for i:= 0 to 93 do begin
    if pSysDefCode = i then begin
       result := vSysDefChar[pSysDefCode];
       break;
    end;
  end;
end;

Function KeyBdChar(pKeyBdCode: smallint): string;
var i: smallint;
begin
  for i := 0 to 93 do begin
    if pKeyBdCode = i then begin
       result := vKeyBdChar[i];
       break;
    end;
  end;
end;

end.
